//+------------------------------------------------------------------+
//|                                                  MACD Sample.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+

extern double TakeProfit = 21;
extern double StopLoss = 14;
extern double Slippage = 3;  
extern double Lots = 0.1;
extern double TrailingStop = 30;
extern double ma=21; 
extern double maa=24;
extern double adxc=7;
extern double adx=21;
extern double adxx=50;
extern double F= 13;
extern double F2= 21;
extern double F3= 50;
extern double vals= 5;
extern double vall= -5;
double val;
double val2;
double val3;
double val1;
double val21;
double val31;
double pips2dbl;
double pips;
double stopLoss, takeProfit, trailingStop;
double realTP, realSL;
double slippage;
double sto;
double rsi;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----

     
   if (Digits == 5 || Digits == 3)    // Adjust for five (5) digit brokers.
   {            
      pips2dbl = Point*10;
   } 
   else 
   {    
      pips2dbl = Point;   
   }
   
   realSL = pips2dbl*stopLoss;
   realTP = pips2dbl*takeProfit;
   slippage = pips2dbl*Slippage;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   double xa;
   double xb;
   double xc;
   double xsp;
   double xxa;
   double xxb;
   double xxc;
   double xxsp;
   double cci;    
   int cnt, ticket, total;
// initial data checks
// it is important to make sure that the expert works with a normal
// chart and the user did not make any mistakes setting external 
// variables (Lots, StopLoss, TakeProfit, 
// TrailingStop) in our case, we check TakeProfit
// on a chart of less than 100 bars
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }
// to simplify the coding and speed up access
// data are put into internal variables
//---- get Moving Average 
   ma=iMA(NULL,0,21,0,MODE_LWMA,PRICE_OPEN,0);
   maa=iMA(NULL,0,24,3,MODE_LWMA,PRICE_WEIGHTED,3);
   adxc=iADX(NULL,0,7,PRICE_WEIGHTED,MODE_OPEN,0);
   adx=iADX(NULL,0,14,PRICE_WEIGHTED,MODE_OPEN,0);
   adxx=iADX(NULL,0,21,PRICE_HIGH,MODE_MAIN,1);
//---- get Force Indicator  
   val=iForce(NULL,0,F,MODE_SMA,PRICE_OPEN,0);
   val2=iForce(NULL,0,F2,MODE_SMA,PRICE_OPEN,0);
   val3=iForce(NULL,0,F3,MODE_SMA,PRICE_OPEN,0);
   val1=iForce(NULL,0,F,MODE_SMA,PRICE_CLOSE,1);
   val21=iForce(NULL,0,F2,MODE_SMA,PRICE_CLOSE,1);
   val31=iForce(NULL,0,F3,MODE_SMA,PRICE_CLOSE,1); 
   cci=iCCI(NULL,0,12,PRICE_TYPICAL,0);  
//---- get ADX 
   double x2=iADX(NULL,0,14,PRICE_CLOSE,MODE_MAIN,0);
   double x3=iADX(NULL,0,21,PRICE_CLOSE,MODE_MAIN,0);
   double x1=iADX(NULL,0,7,PRICE_CLOSE,MODE_MAIN,1);
   double x21=iADX(NULL,0,14,PRICE_CLOSE,MODE_MAIN,1);
   double x31=iADX(NULL,0,21,PRICE_CLOSE,MODE_MAIN,1);
   double x11=iADX(NULL,0,7,PRICE_CLOSE,MODE_MAIN,2);
   double x22=iADX(NULL,0,14,PRICE_CLOSE,MODE_MAIN,2);
   double x33=iADX(NULL,0,21,PRICE_CLOSE,MODE_MAIN,2);
   double xx=iADX(NULL,0,7,PRICE_CLOSE,MODE_MAIN,0);
   double xx2=iADX(NULL,0,14,PRICE_CLOSE,MODE_MAIN,0);
   double xx3=iADX(NULL,0,21,PRICE_CLOSE,MODE_MAIN,0);
   double xx1=iADX(NULL,0,7,PRICE_CLOSE,MODE_MAIN,1);
   double xx21=iADX(NULL,0,14,PRICE_CLOSE,MODE_MAIN,1);
   double xx31=iADX(NULL,0,21,PRICE_CLOSE,MODE_MAIN,1);
   double xx11=iADX(NULL,0,7,PRICE_CLOSE,MODE_MAIN,2);
   double xx22=iADX(NULL,0,14,PRICE_CLOSE,MODE_MAIN,2);
   double xx33=iADX(NULL,0,21,PRICE_CLOSE,MODE_MAIN,2);
//---- get Stoch & RSI for Overbought,Oversold   
   sto=iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,0);
   rsi=iRSI(NULL,0,4,PRICE_CLOSE,0);
 
   total=OrdersTotal();
   if(total<1) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
      // check for long position (BUY) possibility
      if ((adx>adxx) && (ma>maa) && (sto<20 && rsi<30) && (val>val21) && (cci<-125))//Signal Buy
        {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,0,"macd sample",16384,0,Green);
         
                OrderModify(ticket,OrderOpenPrice(),Bid-StopLoss,Ask+TakeProfit*Point,0,White);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
      // check for short position (SELL) possibility
      if ((adx<adxx) && (ma<maa) && (sto>80 && rsi>70) && (val<val21) && (cci>125))//Signal Sell 
        {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,0,"macd sample",16384,0,Red);
         
                OrderModify(ticket,OrderOpenPrice(),Ask+StopLoss,Bid-TakeProfit*Point,0,White);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      return(0);
     }
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...   
   for(cnt=0;cnt<total;cnt--)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            if ((sto>80 && rsi>70) || (adxc<0))
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else // go to short position
           {
            // should it be closed?
            if ((sto<20 && rsi<30) || (adxc>0))OrderClose(OrderTicket(),OrderLots(),Ask,3,White); //Signal B //Signal Buy)
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
   return(0);
  }
// the end.